package qnd;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.util.Hashtable;
import org.sanskritlibrary.IOAssistance;
import org.sanskritlibrary.Regex;

public class ForeignLinks {
    String home = "/Users/ralph/SanskritLibraryHTML/";
    int prefixLength = home.length();
    BufferedWriter bw = null;
    Regex reHTTP = new Regex("", "['\"](http://[^'\"]+?)['\"]");
    Hashtable<String, Boolean> h = new Hashtable<String, Boolean>();
    public ForeignLinks(BufferedWriter bw) throws Exception{
        this.bw = bw;
    }
    
    public void parse() throws Exception {
        File dir = new File(home);
        search(dir);        
    }
    
    public void search(File dir) throws Exception {
        BufferedReader br = null;
        File[] files = dir.listFiles();
        for (File file : files) {
            if (file.isDirectory()) {
                search(file);
            } else if (file.getName().endsWith(".html")) {
                br = IOAssistance.openReader(file.getAbsolutePath());
                String line;
                boolean filenameWritten = false;
                while ((line = br.readLine()) != null) {
                    reHTTP.reset(line);
                    if (reHTTP.find()) {
                        String url = reHTTP.getGroup(1);
                        if (h.get(url) == null) {
                            h.put(url, Boolean.TRUE);
                            if (!filenameWritten) {
                                bw.write(file.getAbsolutePath().substring(prefixLength));
                                bw.write("\n");
                                filenameWritten = true;
                            }
                            bw.write(reHTTP.getGroup(1));
                            bw.write("\n");
                        }
                    }
                }
                if (filenameWritten) {
                    bw.write("\n");
                }
            }
        }
    }
}
