package qnd;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.util.ArrayList;
import java.util.Hashtable;
import org.sanskritlibrary.IOAssistance;
import org.sanskritlibrary.Regex;

public class GoDaddy {
    String filename;
    Hashtable<Character, Boolean> skip = new Hashtable<Character, Boolean>();
    
    public GoDaddy(String filename) {
        this.filename = filename;
        skip.put('│', Boolean.TRUE);
        skip.put('|', Boolean.TRUE);
        skip.put(' ', Boolean.TRUE);
        skip.put('├', Boolean.TRUE);
        skip.put('─', Boolean.TRUE);
        skip.put('└', Boolean.TRUE);
    }
    
    public void parse() throws Exception {
        Regex re = new Regex("", "^(.+?)\\b");
        BufferedReader br = IOAssistance.openReader(filename);
        BufferedWriter bw = IOAssistance.openWriter(filename + "x");
        String line;
        String[] directories = new String[24];
        directories[0] = "/";
        int lineno = 0;
        int maxlevel = 0;
        while ((line = br.readLine()) != null) {
            lineno++;
            if (lineno == 2649) {
                lineno = 2649;
            }
            int length = line.length();
            int i=0;
            for (i=0; i<length; i++) {
                if (skip.get(line.charAt(i)) == null) {
                    break;
                }
            }
            
            int level = i/4;

            if (i%4 != 0) {
                System.out.println(lineno);
                break;
            } else {
                directories[level] = line.substring(i);
            }
            String delim = "/";
            StringBuilder path = new StringBuilder();
            for (i=1; i<=level; i++) {
                path.append(delim);
                path.append(directories[i]);
                delim = "/";
            }
            path.append("\n");
            bw.write(path.toString());
            if (level > maxlevel) {
                maxlevel = level;
            }
        }
        
        br.close();
        bw.close();
    }
}
