package qnd;

import java.io.BufferedWriter;
import java.io.File;
import java.util.ArrayList;
import java.util.Hashtable;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import org.sanskritlibrary.IOAssistance;
import org.sanskritlibrary.SAXParserAdapter;
import org.sanskritlibrary.XMLUtils;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;

public class MDhPNew extends SAXParserAdapter {
    private String filename;
    private Hashtable<String, String> h  = new Hashtable<String, String>();
    private Hashtable<String, String> hpreds = new Hashtable<String, String>();
    private BufferedWriter out;
    private String currentEntryID;
    private String currentPreds;
    
    MDhPNew(String filename) {
        this.filename = filename;
    }

    public void parse() throws Exception {
        SAXParserFactory factory = SAXParserFactory.newInstance();

        //makeGroupComplete("^11(ab)\\(cd\\)(?ef)gh(yz)22$", new Leaf("", ""));
        /*
         SchemaFactory schemaFactory = SchemaFactory.newInstance(XMLConstants.XML_DTD_NS_URI);
         Schema schema = schemaFactory.newSchema(new File("files/rules.dtd"));
         Validator validator = schema.newValidator();
         validator.validate(new StreamSource("files/rules.xml"));
         */

        SAXParser saxParser = factory.newSAXParser();

        // See http://www.saxproject.org/apidoc/org/xml/sax/package-summary.html#package_description
        // Uncomment the following to turn on comment processing.
        // http://docs.oracle.com/javaee/1.4/tutorial/doc/JAXPSAX11.html
        // saxParser.setProperty("http://xml.org/sax/properties/lexical-handler", this);
        try {
            saxParser.parse(new File(filename), this);
        } catch (Exception ex) {
            System.out.format("%d. %s: %s\n", locator.getLineNumber(), filename, ex.toString());
        }
    }
    
    public Hashtable<String, String> getSLPs () {
        return h;
    }
    
    public Hashtable<String, String> getPreds () {
        return hpreds;
    }
    
    @Override
    public void startDocument () throws SAXException {
        try {
        } catch (Exception ex) {
            throw new SAXException(ex);
        }
    }
    
    @Override
    public void endDocument() throws SAXException {
        try {
            
        } catch (Throwable ex) {
            throw new SAXException(ex.getMessage());
        }
    }
    
    
    @Override
    public void startElement(String uri, String localName, String qName, Attributes atts) throws SAXException {
        if (locator.getLineNumber() == 6) {
            localName = null;
        }
        push(qName, atts);
        String path = buildPath();
        if (qName.equals("entry")) {
            if (!path.contains("pAWAntara")) {
                currentEntryID = atts.getValue("id");
                currentPreds = atts.getValue("preds");
                if (currentPreds == null) {
                    currentPreds = "none";
                }                
            }            
        } else if (qName.equals("fullDAtu")) {
            if (!path.contains("pAWAntara")) {
                if (currentEntryID != null) {
                    String slp = atts.getValue("slp");
                    if (h.get(currentEntryID) != null) {
                        System.out.format("%s not unique", currentEntryID);
                    } else {
                        h.put(currentEntryID, slp);
                        hpreds.put(currentEntryID, currentPreds);
                    }
                }  
            }
        }
    }

    @Override
    public void endElement(String uri, String localName, String qName) throws SAXException {
        String path = buildPath();
        String value = "";
        StringBuilder sb = buffers.get(path);
        if (sb != null) {
            value = sb.toString().trim();
            sb.setLength(0);
        }
        
        pop();
    }
    
    @Override
    public void characters(char[] ch, int start, int length) throws SAXException {
        String path = buildPath();
        StringBuilder buffer = buffers.get(path);
        if (buffer == null) {
            buffer = new StringBuilder();
            buffers.put(path, buffer);
        }
        buffer.append(new String(ch, start, length));
    }    
}
