/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package qnd;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Hashtable;
import org.sanskritlibrary.IOAssistance;
import org.sanskritlibrary.Regex;
import org.sanskritlibrary.TextFormatter;

/**
 *
 * @author ralph
 */
public class PDFFixup implements Comparator {
    String lastOut = null;
    int sortType = 0;
    String oldDirectoryName = "OldName/";
    int lengthOldDirectoryName = oldDirectoryName.length();
    String newDirectoryName = "NewName/";
    int lengthNewDirectoryName = newDirectoryName.length();
    Regex re1 = new Regex("", "p(\\d+)");
    Regex re2 = new Regex("", "p(\\d+)-p?(\\d+)");
    void pdfFixup(String infile, String outfile, String directory) throws Exception {
        Hashtable<String, Integer> inputHash = new Hashtable<String, Integer>();
        Hashtable<String, Integer> outputHash = new Hashtable<String, Integer>();
        Hashtable<String, Integer> directoryHash = new Hashtable<String, Integer>();
        
        String[] directoryFiles = IOAssistance.readEntireFile(directory).split("\n");
        for (String directoryFile : directoryFiles) {
            directoryHash.put(directoryFile.trim(), 0);
        }
        
        String input = IOAssistance.readEntireFile(infile);
        BufferedWriter bw = IOAssistance.openWriter(outfile);
        int[] result = new int[2];
        String[] lines = input.split("\n");
        int lineNumber = 0;
        
        for (String line : lines) {
            lineNumber++;
            int sourceStart, sourceEnd, targetStart, targetEnd;
            line = line.trim();
            String[] fields = line.split("\t");
            if (fields.length < 5) {
                if (line.length() != 0) {
                    System.out.println(line);
                }
                continue;
            }
            parseRange(fields[1], result);
            targetStart = result[0];
            targetEnd = result[1];
            parseRange(fields[3], result);
            sourceStart = result[0];
            sourceEnd = result[1];
            if (sourceEnd - sourceStart != targetEnd - targetStart) {
                System.out.format("Bad line: %s\n", line);
                continue;
            }            
            String harvardPrefix = fields[0];
            String filename = fields[2].substring(0, fields[2].length()-4);
            for (int i=sourceStart, j=targetStart; i<=sourceEnd; i++, j++) {
                /*
mv acsamDat_hsection2-1700_p001.pdf 1700_001.pdf
mv OldName/acsamDat_hsection2-1700_p001.pdf NewName/h1700acsamdat_p01.pdf                 */
                String in = String.format("acsamDat_h%s_p%s.pdf", filename, TextFormatter.intToString(i, 3));
                String out = String.format("%sh%sacsamdat_p%s.pdf", newDirectoryName, harvardPrefix, TextFormatter.intToString(j, 2));
                if (inputHash.get(in) == null) {
                    Integer n = directoryHash.get(in);      // see if this exists because of a previous renaming
                    if (n == null) {
                        System.out.format("Not in list of split pdfs: %s (%d)\n", in, lineNumber);
                        continue;
                    } else if (n.intValue() != 0){       // have already seen this output file                          
                        System.out.format("Skipping duplicate output (%d and %d): %s\n", n, lineNumber, out);
                        continue;
                    } else {
                        directoryHash.put(out, lineNumber);
                    }
                    inputHash.put(in, lineNumber);                    
                    bw.write(String.format("mv %s%s %s\n", oldDirectoryName, in, out));
                    lastOut = out;
                } else {
                    String abbreviatedName = out.substring(lengthNewDirectoryName);
                    abbreviatedName = abbreviatedName.substring(0, abbreviatedName.length()-4);
                    System.out.format("%s shown in %s\n", abbreviatedName, 
                                    lastOut.substring(lengthNewDirectoryName));
//                    System.out.format("Skipping duplicate input (%d and %d): %s\n", inputHash.get(in), lineNumber, in);
                }
            }
        }
        bw.close();
    }

    
    void pdfFixup2(String infile, String outfile) throws Exception {
        String input = IOAssistance.readEntireFile(infile);
        BufferedWriter bw = IOAssistance.openWriter(outfile);
        int[] result = new int[2];
        String[] lines = input.split("\n");
        ArrayList<PDFInfo> pdfInfo = new ArrayList<PDFInfo>();
        int lineNumber = 0;
        for (String line : lines) {
            lineNumber++;
            int sourceStart, sourceEnd, targetStart, targetEnd;
            line = line.trim();
            String[] fields = line.split("\t");
            if (fields.length < 5) {
                if (line.length() != 0) {
                    System.out.println(line);
                }
                continue;
            }
            parseRange(fields[1], result);
            targetStart = result[0];
            targetEnd = result[1];
            parseRange(fields[3], result);
            sourceStart = result[0];
            sourceEnd = result[1];
            if (sourceEnd - sourceStart != targetEnd - targetStart) {
                System.out.format("Bad line: %s\n", line);
                continue;
            }            
            String harvardPrefix = fields[0];
            String filename = fields[2];
            
            String author = "none";            
            if (fields.length > 4) {
                author = fields[4];
            }
            
            String comment = "";
            if (fields.length > 5) {
                comment = fields[5];
            }
            
            for (int i=targetStart, j=sourceStart; i<=targetEnd; i++, j++) {
                PDFInfo pi = new PDFInfo();
                pdfInfo.add(pi);
                pi.harvard = harvardPrefix;
                pi.targetPage = i;
                pi.filename = filename;
                pi.sourcePage = j;
                pi.author = author;
                pi.comment = comment;
                pi.originalLine = lineNumber;
            }
        }
        
        bw.write("Request 2.\n");
        sortType = 0;
        Collections.sort(pdfInfo, this);
        String lastHarvard = "xxx";
        int lastTarget = -1;
        for (PDFInfo pi : pdfInfo) {
            if (pi.harvard.equals(lastHarvard) && pi.targetPage == lastTarget) {
                bw.write("*");
            } else {
                bw.write(" ");
            }
            lastHarvard = pi.harvard;
            lastTarget = pi.targetPage;
            bw.write(pi.toString());
            bw.write("\n");
        }
        
        bw.write("\n\nRequest 3.\n");
        
        sortType = 1;
        Collections.sort(pdfInfo, this);
        String lastFilename = "xxx";
        int lastSource = -1;
        for (PDFInfo pi : pdfInfo) {
            if (pi.filename.equals(lastFilename) && pi.sourcePage == lastSource) {
                bw.write("!");
            } else {
                bw.write(" ");
            }
            lastFilename = pi.filename;
            lastSource = pi.sourcePage;
            bw.write(pi.toString());
            bw.write("\n");
        }
        bw.close();
    }
    
    
    
    void sortScript() throws Exception {
        String sortedByHand = "/Users/ralph/Downloads/SortByHand2/indexSortedByHand.txt";
        BufferedReader br = IOAssistance.openReader(sortedByHand);
        Hashtable<String, HandSortInfo> h = new Hashtable<String, HandSortInfo>();
        String line;
        int lineNumber = 0;
        while ((line=br.readLine()) != null) {
            lineNumber++;
            if (lineNumber == 1175) {
                lineNumber = 1175;
            }
            if (line.charAt(0) != '#') {
                String[] fields = line.split("\t");
                HandSortInfo hsi = new HandSortInfo(fields, lineNumber);
                HandSortInfo sofar = h.get(hsi.key);
                if (sofar == null) {
                    h.put(hsi.key, hsi);
                } else {
                    sofar.addPages(fields[1]);
                }
            }
        }
        br.close();
        
        addColumn(h, "/Users/ralph/Downloads/SortByHand2/dataSheetImagesIndex.txt");
        addColumn(h, "/Users/ralph/Downloads/SortByHand2/dataSheetImagesIndexMalten.txt");
        createScript("/Users/ralph/Downloads/SortByHand2/dataSheetImagesIndexMaltenWithHand.txt",
                "/Users/ralph/Downloads/SortByHand2/sortbyhand.sh");
    }
    
    static Regex reHand = new Regex("", "^h(\\d{4}(?:cjm|czm|dep|klp|tlk|[etnabAB]|v1|v2|))acsamdat_p(\\d{2})\\.pdf$");
    private void addColumn (Hashtable<String, HandSortInfo> h, String filename) throws Exception {
        int n = 0;
        BufferedReader br = IOAssistance.openReader(filename);
        String out = filename.replace(".txt", "WithHand.txt");
        System.out.format("%s: Adding hand column to create %s\n", new File(filename).getName(), new File(out).getName());
        BufferedWriter bw = IOAssistance.openWriter(out);
        String line;
        String page;
        int numFound = 0;
        while ((line=br.readLine()) != null) {
            n++;
            boolean found = false;
            reHand.reset(line);
            if (reHand.find()) {
                String hand = reHand.getGroup(1);
                HandSortInfo hsi = h.get(hand);
                if (hsi != null) {
                    page = reHand.getGroup(2);
                    if (hsi.pages.contains(page)) {
                        found = true;
                        numFound++;
                        bw.write(String.format("%s\t%s\n", line, hsi.hand));
                    } else {                        
                        System.out.format("%d. %s: key %s found in indexSortedByHand.txt but only pages %s were found for this key.\n", 
                                n, line, hand, stringify(hsi.pages));
                    }
                } else {
                    System.out.format("%d. %s: key %s not found in indexSortedByHand.txt\n", n, line, hand);
                }
            } else {
                System.out.format("%d. %s: no match\n", line);
            }
            if (!found) {
                bw.write(String.format("%s\t?\n", line));
            }
        }
        System.out.format("%d of %d found\n", numFound, n);
        br.close();
        bw.close();
    }
    
    
    private String stringify(ArrayList<String> a) {
        StringBuilder sb = new StringBuilder();
        String delim = "";
        for (String s : a) {
            sb.append(delim);
            delim = ", ";
            sb.append(s);
        }
        
        return sb.toString();
    }
    
    
    private void createScript(String filename, String scriptname) throws Exception {
        BufferedReader br = IOAssistance.openReader(filename);
        BufferedWriter bw = IOAssistance.openWriter(scriptname);
        Hashtable<String, ArrayList<String>> h = new Hashtable<String, ArrayList<String>>();
        String line;
        int n = 0;
        System.out.format("Creating script from %s\n", new File(filename).getName());
        while ((line = br.readLine()) != null) {
            String[] columns = line.split("\t");
            if (columns.length == 2) {
                String key = columns[1];
                ArrayList<String> a = h.get(key);
                if (a == null) {
                    a = new ArrayList<String>();
                    h.put(key, a);
                }
                a.add(columns[0]);
            }
        }
        
        String[] hands = new String[] {
            "cjm",
            "czm",
            "dep",
            "klp",
            "tlk"  
        };
        
        for (String hand : hands) {
            ArrayList<String> a = h.get(hand);
            for (String s : a) {
                bw.write(String.format("cp DataSheetImagesMalten/%s DataSheetImagesSortedByHand/%s\n", s, hand));
            }
        }
        
        br.close();
        bw.close();
    }
    
    void parseRange(String range, int[] result) throws Exception {
            if (range.contains("-")) {
                re2.reset(range);
                if (re2.find()) {
                    result[0] = Integer.parseInt(re2.getGroup(1));
                    result[1] = Integer.parseInt(re2.getGroup(2));                    
                } else {
                    throw new Exception(String.format("Bad range: %s", range));
                }
            } else {
                re1.reset(range);
                if (re1.find()) {
                    result[0] = Integer.parseInt(re1.getGroup(1));
                    result[1] = result[0];
                } else {
                    throw new Exception(String.format("Bad range: %s", range));
                } 
            }
        
    }

    @Override
    public int compare(Object t, Object t1) {
        PDFInfo pi1 = (PDFInfo)t;
        PDFInfo pi2 = (PDFInfo)t1;
        int comp = 0;
        if (sortType == 0) {
            comp = pi1.harvard.compareTo(pi2.harvard);
            if (comp == 0) {
                comp = pi1.targetPage - pi2.targetPage;
            } 
        } else {
            comp = pi1.filename.compareTo(pi2.filename);
            if (comp == 0) {
                comp = pi1.sourcePage - pi2.sourcePage;
            }             
        }
        
        return comp;
    }
    
    public class PDFInfo {
        String harvard;
        int targetPage;
        String filename;
        int sourcePage;
        String author;
        String comment;
        int originalLine;
        
        @Override
        public String toString() {
            String s = String.format("%s\tp%d\t%s\tp%d\t%s", harvard, targetPage, filename, sourcePage, author);
            if (comment.length() > 0) {
                s += "\t" + comment;
            }
            s += String.format("[%s]", originalLine);
            
            return s;
        }
    }

    static Regex reSorted = new Regex("", "p(\\d+)-(\\d+)");
    public class HandSortInfo {
        String key;         // column 1
        ArrayList<String> pages = new ArrayList<String>();        // column 2
        String hand;         // column 5
        int lineNumber;
        HandSortInfo(String[] fields, int lineNumber) {
            this.key = fields[0];
            addPages(fields[1]);        // column 2
            this.hand = fields[4];
            int idx = this.hand.indexOf(",");
            if (idx != -1) {
                this.hand = this.hand.substring(0, idx);
            }
            this.lineNumber = lineNumber;
        }
        
        void addPages(String additionalPages) {
            reSorted.reset(additionalPages);
            int first;
            int last;
            if (reSorted.find()) {
                first = Integer.parseInt(reSorted.getGroup(1));
                last = Integer.parseInt(reSorted.getGroup(2));
            } else {
                first = Integer.parseInt(additionalPages.substring(1));
                last = first;
            }
            
            for (int i=first; i<=last; i++) {
                pages.add(fixup(i));
            }
        }
        
        String fixup(int n) {
            if (n < 10) {
                return "0" + n;
            } else {
                return "" + n;
            }
        }
    }
    
}
