package qnd;

import org.sanskritlibrary.panini.PratipadikaFile;
import org.sanskritlibrary.panini.XMLRulesCompleted;
import org.sanskritlibrary.panini.PaniniDatabase;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Enumeration;
import java.util.Hashtable;
import org.sanskritlibrary.Config;
import org.sanskritlibrary.IOAssistance;
import org.sanskritlibrary.Regex;
import org.sanskritlibrary.TextFormatter;

public class QnD implements Comparator<String> {
    int margin = 1;
    static final Hashtable<Character, Boolean> vowels = new Hashtable<Character, Boolean>();
    static final Hashtable<Character, Boolean> consonents = new Hashtable<Character, Boolean>();

    static {
        vowels.put('a', Boolean.TRUE);
        vowels.put('A', Boolean.TRUE);
        vowels.put('i', Boolean.TRUE);
        vowels.put('I', Boolean.TRUE);
        vowels.put('u', Boolean.TRUE);
        vowels.put('U', Boolean.TRUE);
        vowels.put('f', Boolean.TRUE);
        vowels.put('F', Boolean.TRUE);
        vowels.put('x', Boolean.TRUE);
        vowels.put('X', Boolean.TRUE);
        vowels.put('e', Boolean.TRUE);
        vowels.put('E', Boolean.TRUE);
        vowels.put('o', Boolean.TRUE);
        vowels.put('O', Boolean.TRUE);
        vowels.put('H', Boolean.TRUE);
        vowels.put('M', Boolean.TRUE);

        consonents.put('k', Boolean.TRUE);
        consonents.put('K', Boolean.TRUE);
        consonents.put('g', Boolean.TRUE);
        consonents.put('G', Boolean.TRUE);
        consonents.put('N', Boolean.TRUE);

        consonents.put('c', Boolean.TRUE);
        consonents.put('C', Boolean.TRUE);
        consonents.put('j', Boolean.TRUE);
        consonents.put('J', Boolean.TRUE);
        consonents.put('Y', Boolean.TRUE);

        consonents.put('w', Boolean.TRUE);
        consonents.put('W', Boolean.TRUE);
        consonents.put('q', Boolean.TRUE);
        consonents.put('Q', Boolean.TRUE);
        consonents.put('R', Boolean.TRUE);

        consonents.put('t', Boolean.TRUE);
        consonents.put('T', Boolean.TRUE);
        consonents.put('d', Boolean.TRUE);
        consonents.put('D', Boolean.TRUE);
        consonents.put('n', Boolean.TRUE);

        consonents.put('p', Boolean.TRUE);
        consonents.put('P', Boolean.TRUE);
        consonents.put('b', Boolean.TRUE);
        consonents.put('B', Boolean.TRUE);
        consonents.put('m', Boolean.TRUE);

        consonents.put('y', Boolean.TRUE);
        consonents.put('r', Boolean.TRUE);
        consonents.put('l', Boolean.TRUE);
        consonents.put('v', Boolean.TRUE);

        consonents.put('s', Boolean.TRUE);
        consonents.put('S', Boolean.TRUE);
        consonents.put('z', Boolean.TRUE);

        consonents.put('L', Boolean.TRUE);
        consonents.put('|', Boolean.TRUE);
    }

    public static void main(String[] args) throws Exception {
        QnD qnd = new QnD();
        //qnd.renamingFiles();
        //qnd.extractSentences ();
        //qnd.createTranscodingPairs();
        //qnd.createTemplate();
        //qnd.analyzeDistributionForOCR("/Users/ralph/SanskritLibrary/data/texts/BhG.slp");
        //qnd.collectDependencyTags("/Users/ralph/SanskritLibrary/Paul/RamSaved/");
        //qnd.ocrPrep ();
        //qnd.oliverReverseEngineer();
        //qnd.foo(24, 2); 
        //qnd.MDhP();
        //qnd.compare();
        //qnd.pratipadika(args);
        //qnd.convertCoordinates("/Users/ralph/Downloads/12-098 ffld trail mapping.csv");
        //qnd.toJSON("/Users/ralph/Downloads/12-098 ffld trail mapping.csv");
        //qnd.convertXMLRules();
        //qnd.convertPradipadika();
//        qnd.generateRules();
        //qnd.countPages();
        //qnd.addTags("/Users/ralph/MUM/CS473/Demos/chap01/chap01.html");
        
        //qnd.studentList("/Users/ralph/MUM/CS473/StudentAppData/classlist.csv",
        //        "/Users/ralph/MUM/CS473/StudentAppData/students.xml");
        //qnd.findLifecycleFiles("/Users/ralph/MUM/CS473/AndroidProgramming");
        //qnd.extractImageNames("/Users/ralph/Donglai/ocrprepAnuTanuFinal.txt");
        //qnd.updateZones(args);
        //alphawords("/Users/ralph/Crucimetrics/english-words.txt");
        //new Crosswords().dataMining();
        //OCRPrep.convertToXML("/Users/ralph/Donglai/ocr.txt", "/Users/ralph/Donglai/ocr.xml", "/Users/ralph/NetBeansProjects/ManuscriptViewer/web/ocr.xml");
        
        /*
        for (int i=1; i<=20; i++) {
            OCRPageSelection ops = new OCRPageSelection("/Users/ralph/SanskritLibrary/data/texts/BhP11.slp", i);
            int totalLines = ops.execute();
            if (totalLines >= 400) {
                break;
            }
        }
        */
        
        //qnd.trailApp();
        
        /*
        if (args[0].equals("script")) {
            qnd.pdfFixup(args[1], args[2], args[3]);        
        } else if (args[0]. equals("sort")) {
            qnd.pdfFixup2(args[1], args[2]);        
        }
        */
        //qnd.sortByHand();
        qnd.godaddy();
        //qnd.foreignLinks();
    }
    
    
    void foreignLinks() throws Exception {
        BufferedWriter bw = IOAssistance.openWriter("foreignLinks.txt");
        ForeignLinks fl = new ForeignLinks(bw);
        fl.parse();
        bw.close();
    }
    
    void godaddy() throws Exception {
        GoDaddy gd = new GoDaddy("godaddy.txt");
        gd.parse();
    }
    
    void pdfFixup(String infile, String outfile, String directory) throws Exception {        
        PDFFixup pf = new PDFFixup();
        pf.pdfFixup(infile, outfile, directory);
    }

    void pdfFixup2(String infile, String outfile) throws Exception {
        PDFFixup pf = new PDFFixup();
        pf.pdfFixup2(infile, outfile);
    }
    
    void sortByHand() throws Exception {
        PDFFixup pf = new PDFFixup();
        pf.sortScript();
    }
    
    static private void alphawords(String filename) throws Exception {
        BufferedReader br = IOAssistance.openReader(filename);
        String line;
        while ((line = br.readLine()) != null) {
            line = line.trim();
            int len = line.length();
            char last = ' ';
            boolean found = true;
            for (int i=0; i<len && found; i++) {
                if (last <= line.charAt(i)) {
                    last = line.charAt(i);
                } else {
                    found = false;
                }
            }
            if (found && line.length() == 5) {
                System.out.println(line);
            }
        }
        br.close();
    }
    
    
    private void updateZones (String[] args) throws Exception {
        if (args.length < 2) {
            System.out.format("Usage: java -jar dist/QnD.jar resplitDirectory xmlDirectory\n");
            return;
        }
        File f = new File(args[0]);
        if (!f.exists()) {
            System.out.format("The resplitDirectory:%s does not exist.\n", args[0]);
            return;
        }
        f = new File(args[1]);
        if (!f.exists()) {
            System.out.format("The xmlDirectory:%s does not exist.\n", args[1]);
            return;
        }
        ZoneUpdate zu = new ZoneUpdate(args[0], args[1]);
        zu.update();
    }

    
    private void extractImageNames(String filename) throws Exception {
        BufferedReader br = IOAssistance.openReader(filename);
        String line;
        int lineNumber = 0;
        while ((line=br.readLine()) != null) {
            lineNumber++;
            if (lineNumber == 4) {
                lineNumber = 4;
            }
            if (line.contains("image:")) {
                line = line.substring(6).trim();
                if (!line.equals("Unknown")) {
                    line = line.replace("/Users/pscharf/Documents/Cittasaya/SanskritLibrary/NEHManuscriptProject/mss/images/UPennCropped/",
                            "/Users/ralph/DongleiZones/UPenn_s/");                    
                    System.out.format("cp %s .\n", line);
                }
            }
         }
        br.close();
    }
    
    private void findLifecycleFiles (String dirname) throws Exception {
        BufferedWriter bw = IOAssistance.openWriter("lifecycle.txt");
        lifeCycle(bw, dirname);
        bw.close();
    }
    
    private void lifeCycle (BufferedWriter bw, String dirname) throws Exception {
        
        File dirs = new File(dirname);
        for (File f : dirs.listFiles()) {
            if (f.isDirectory()) {
                lifeCycle (bw, f.getAbsolutePath());
            } else {
                String fn = f.getName();
                if (fn.endsWith(".java")) {
                    searchFile(bw, f.getAbsolutePath());
                }
            }
        }
    }
    
    private void searchFile(BufferedWriter bw, String filename) throws Exception {
        BufferedReader br = IOAssistance.openReader(filename);
        String line;
        int printCount = 0;
        while ((line = br.readLine()) != null) {
            if (line.contains("void onStart") || line.contains("void onResume") || line.contains("void onPause") || 
                line.contains("void onStop") || line.contains("void onDestroy")) {
                bw.write("---------------\n");
                bw.write(filename);
                printCount = 10;
                bw.write("\n");
            }
            if (printCount != 0) {
                bw.write(line);
                bw.write("\n");
                printCount--;
            }
        }
        br.close();
    }
    
    private void studentList(String filename, String xml) throws Exception {
        BufferedReader br = IOAssistance.openReader(filename);
        BufferedWriter bw = IOAssistance.openWriter(xml);
        String line;
        bw.write("<students>\n");
        while ((line = br.readLine()) != null) {
            String[] fields = line.split(",");
            bw.write(" <student");
            
            bw.write(String.format(" id=\"%s\"", fields[0]));
            bw.write(String.format(" sid=\"%s\"", fields[1]));
            bw.write(String.format(" firstName=\"%s\"", fields[2]));
            bw.write(String.format(" lastName=\"%s\"", fields[3]));
            bw.write(String.format(" resourceName=\"%s_%s\"", fields[2].toLowerCase(), fields[3].toLowerCase()));
            bw.write(String.format(" entry=\"\""));
            bw.write(String.format(" country=\"\""));
            bw.write("/>\n");
        }
        bw.write("</students>\n");
        br.close();
        bw.close();
    }
    
    private void addTags (String filename) throws Exception {
        Regex reSpan = new Regex("", "<span id=[\"'](.*?)[\"']");
        String patternBang = "(#.+?#)";
        Regex reBang = new Regex("", patternBang);
        BufferedReader br = IOAssistance.openReader(filename);
        int idx = filename.lastIndexOf(".");
        String tempFile = filename.substring(0, idx) + ".temp" + filename.substring(idx);
        BufferedWriter bw = IOAssistance.openWriter("tags.txt");
        BufferedWriter bwTemp = IOAssistance.openWriter(tempFile);
        String line;
        
        while ((line = br.readLine()) != null) {
            if (line.contains("<span id")) {
                reSpan.reset(line);
                if (reSpan.find()) {
                    String id = reSpan.getGroup(1);
                    bw.write(String.format("<a name=\"%s\"/>\n", id));
                    bw.write(String.format("<div id=\"%s\">\n", id));
                    bw.write(String.format("<p>%s</p>\n", id));
                    bw.write("</div>\n\n");
                }
            }
        
            if (line.contains("#")) {
                reBang.reset(line);
                if (reBang.find()) {
                    String id = reBang.getGroup(1);
                    id = id.substring(1, id.length() - 1);
                    String replacement = String.format("<span id=\"%s\"></span>", id);
                    line = line.replaceAll(patternBang, replacement);
                }
            }

            bwTemp.write(line);
            bwTemp.write("\n");
        }
        
        br.close();
        bw.close();
        bwTemp.close();
        
        File f = new File(filename);
        f.delete();
        f = new File(tempFile);
        f.renameTo(new File(filename));
    }
    
/*
<a name="versionName"/>
<div id="versionName">
	<p>The version number shown to users. This attribute can be set as a raw string or as a reference to a string resource. The string has no other purpose than to be displayed to users. The versionCode attribute holds the significant version number used internally.	
</div>	

 */    
    
    private void countPages () throws Exception {
        int totalCount = 0;
        int countMBh = 0;
        File dir = new File("/Users/ralph/SanskritLibrary/data/texts");
        File[] files = dir.listFiles();
        for (File file : files) {
            String fn = file.getName();
            if (fn.contains(".slp")) {
                System.out.print(fn);
                System.out.print(" ");
                int count = 0;
                BufferedReader br = IOAssistance.openReader(file.getAbsolutePath());
                String line;
                while ((line=br.readLine())!=null) {
                    line = line.trim();
                    if (line.length() == 0) {
                        continue;
                    }
                    if (line.charAt(0) == '%') {
                        continue;
                    }
                    if (Character.isDigit(line.charAt(0))) {
                        int idx = line.indexOf(" ");
                        if (idx != -1) {
                            line = line.substring(idx+1);
                        } else {
                            idx = line.indexOf("\t");
                            if (idx != -1) {
                                line = line.substring(idx+1);
                            }
                        }
                    }
                    count += countSyllables(line);
                }
                System.out.println((long)Math.round(count/420.0));
                if (fn.startsWith("MBh") && !fn.contains("Supp")) {
                    countMBh += count;
                }
                totalCount += count;
                br.close();
            }
        }
        
        System.out.format("MBh count: %d\n", (long)Math.round(countMBh/420.0));
        System.out.println((long)Math.round(totalCount/420.0));
    }
    
    private int countSyllables (String line) {
        int count = 0;
        reVowel.reset(line);
        while (reVowel.find()) {
            count++;
        }
        return count;
    }

      static int length(int n) {   // returns the number of digits in n. Assumes n is >= 0
        int numDigits = 0;
        while (n > 0) {
            numDigits++;
            n = n / 10;
        }
        if (numDigits == 0) {
            numDigits = 1;
        }
        return numDigits;
    }

    static int nthDigit(int number, int n) {  // returns the nth digit of number. Rightmost digit is digit 0. Assumes n is positive
        int digit = 0;
        for (int i = 0; i <= n; i++) {
            digit = number % 10;
            number /= 10;
        }

        return digit;
    }

    static int foo (int n1, int n2) {
        n1 = Math.abs(n1);
        n2 = Math.abs(n2);
        int len = length(n1);

        if (length(n2) != len) {
            return 0;
        }
        
        int diff = 0;
        for (int i=0; i<len; i++) {
            if (nthDigit(n1, i) != nthDigit(n2, i)) {
                if (diff++ > 0) {
                    return 0;
                }
            }
        }
        
        return diff == 1 ? 1 : 0;
    }

    
    static void wordLadder () {
        char[] a = new char[] {'C', 'O', 'L', 'D'};
        int b[] = new int[] {2, 4, 8, 16};
        String[] ladder = new String[4];
        int numLadders = 0;
        
        for (int c1 = 0; c1<4; c1++) {
            for (int c2 = 0; c2<4; c2++) {
                for (int c3 = 0; c3<4; c3++) {
                    for (int c4=0; c4<4; c4++) {
                        if (b[c1] + b[c2] + b[c3] + b[c4] == 30 ) {
                            StringBuilder sb = new StringBuilder("WARM");
                            sb.setCharAt(c1, a[c1]);
                            ladder[0] = sb.toString();
                            sb.setCharAt(c2, a[c2]);
                            ladder[1] = sb.toString();
                            sb.setCharAt(c3, a[c3]);
                            ladder[2] = sb.toString();                            
                            sb.setCharAt(c4, a[c4]);
                            ladder[3] = sb.toString();
                            if (ladder[3].equals("COLD")) {
                                System.out.println("WARM");
                                for (int i=0; i<4; i++) {
                                    System.out.println(ladder[i]);
                                }
                                System.out.println("----------");
                                numLadders++;
                            }
                        }
                    }
                }
            }
        }
        
        System.out.println(numLadders);
    }

  
    public void convertXMLRules () throws Exception {
        ConvertXMLRuleFormat rf = new ConvertXMLRuleFormat("PaniniConversion/Participle2010Oct26.xml", "par");
        rf.parse();
        rf = new ConvertXMLRuleFormat("PaniniConversion/Conj2004June2.xml", "con");
        rf.parse();
        Enumeration<String> en = ConvertXMLRuleFormat.rules.keys();
        ArrayList<String> a = new ArrayList<String>();
        while (en.hasMoreElements()) {
            a.add(en.nextElement());
        }
        Collections.sort(a, this);        
        
        XMLRulesCompleted xrc = new XMLRulesCompleted("/Users/Ralph/PaniniDB/rules.xml");
        xrc.parse();
        
        BufferedWriter bw = IOAssistance.openWriter("convertedRules.xml");
        bw.write("<rules>\n");
        for (String key : a) {
            bw.write(String.format(" <rule n=\"%s\"", key));
            if (xrc.completedManually.get(key) != null) {          // if completed manually
                bw.write(" completed=\"true\"");
            }
            ArrayList<RuleInfo> aa = ConvertXMLRuleFormat.rules.get(key);
            boolean conjFound = false;
            boolean partFound = false;
            for (RuleInfo ri : aa) {
                if (ri.tag.equals("par")) {
                    partFound = true;
                } else if (ri.tag.equals("con")) {
                    conjFound = true;
                }
            }
            
            if (partFound && conjFound) {
                bw.write(" both=\"true\"");
                if (aa.size() > 2) {
                    bw.write(" cases=\"true?\"");                    
                }
            } else if (aa.size() > 1) {
                bw.write(" cases=\"true?\"");
            }
            
            bw.write(String.format(" s=\"%s\">\n", aa.get(0).sutra));
            for (RuleInfo ri : aa) {
                bw.write(String.format("  %s\n", ri.toString()));
            }
            bw.write(" </rule>\n\n");
        }
        bw.write("</rules>");
        bw.close();
        
        ConvertIntermediateXML cix = new ConvertIntermediateXML("convertedRules.xml", null);
        cix.parse();
    }

        
    public void toJSON (String filename) throws Exception {
        String outfile;
        String delim = "";
        BufferedReader br = IOAssistance.openReader(filename);
        outfile = "points.js";
        BufferedWriter bw = IOAssistance.openWriter(outfile);
        String line;
        bw.write("var points=[\n");
        while ((line=br.readLine()) != null) {
            String[] fields = line.split(",");
            bw.write(String.format("%s{x:%s, y:%s, z:%s}", delim, fields[2], fields[1], fields[3]));
            delim = ",\n";
        }
        bw.write("];");
        bw.close();
        br.close();        
    }

    public void convertCoordinates(String filename) throws Exception {
        String outfile;
        BufferedReader br = IOAssistance.openReader(filename);
        int idx = filename.indexOf(".");
        outfile = filename.substring(0, idx) + "X.csv";
        BufferedWriter bw = IOAssistance.openWriter(outfile);
        String line;
        bw.write("Position\n");
        //0502 3907551.941ft 1554292.482ft 
        while ((line=br.readLine()) != null) {
            String[] fields = line.split(",");
            bw.write(String.format("1402 %sftUS %sftUS\n", fields[2], fields[1]));
        }
        bw.close();
        br.close();
    }
    
    public void trailApp() throws Exception {
        //TrailApp ta = new TrailApp("/Users/ralph/IOSLoopApp/12-098 ffld trail mapping.csv");
        //ta.parse();
        TrailApp ta = new TrailApp("/Users/ralph/MobilDeviceProgramming/workspace/LoopTrail/assets/www");
        ta.getElevations();
    }
    
    public void pratipadika(String[] args) throws Exception {
        // /Users/ralph/p/penndb/pratipadika.txt
        String header = "f\tPN\tPratN\tSLP\tPratipadika\tCompound\tLexId\tSubLexId\tMarker\tPronunciation\tTapara\n";
        String separator = " \t \t \t \t \t \t \t \t \t \t \n";
        Hashtable<String, ArrayList<String>> h = new Hashtable<String, ArrayList<String>>();
        Hashtable<String, Boolean> hkey = new Hashtable<String, Boolean>();
        BufferedReader br = IOAssistance.openReader(args[0]);
        BufferedWriter bw = IOAssistance.openWriter("pratipadika.html");
        BufferedWriter bw2 = IOAssistance.openWriter("pratipadikaSLP.txt");
        String line;
        bw.write("<html><head><style type='text/css'>.red{color:red}\n.green{color:orange; font-style:bold}</style></head><body><table border='1px' style='border-collapse:collapse'>");
        int count = 0;
        while ((line = br.readLine()) != null) {
            String[] fields = line.split("\t");
            String pratipadika = fields[3];
            String marker = fields[7];
            String pronounciation = fields[8];
            
            String id = String.format("%s.%s.%s", fields[0], fields[1], fields[2]);
            if (hkey.get(id) != null) {
                System.out.format("Duplicate first three fields: line %d. %s\n", count, id);
            } else {
                hkey.put(id, Boolean.TRUE);
            }
            if (count == 0) {
                bw2.write(header);
            } else {
                addSLP(bw2, fields);
            }
            if (marker.length() > 0 || pronounciation.length() > 0) {
                if (count > 0 && isVowel(marker) && isVowel(pronounciation)) {
                    System.out.format("%s.%s\n", fields[0], fields[1]);
                }
                String value = String.format("%s*%s*%s*%s", fields[5], fields[6], fields[7], fields[8]);
                String key = String.format("%s.%s.%s", fields[0], fields[1], fields[2]);
                ArrayList<String> before = h.get(pratipadika);
                if (before == null) {
                    before = new ArrayList<String>();
                    h.put(pratipadika, before);
                }
                
                before.add(line);
                

                bw.write("<tr>");
                int n = 0;
                for (String field : fields) {
                    if (n == 9) {
                        continue;
                    }
                    if (n == 3) {
                        if (count == 0) {
                            bw.write(String.format("<td>%s</td>", "slp"));
                        } else {
                            bw.write(String.format("<td>%s</td>", addMarkers(pratipadika, marker, pronounciation)));
                        }
                    }
                    String out = field;
                    if (out.length() > 20) {
                        out = out.substring(0, 20) + "...";
                    }
                    bw.write(String.format("<td>%s</td>", out));
                    n++;
                }
                bw.write("</tr>\n");
            }
            count++;
        }

        bw.write("</table></body></html>\n");
        bw.close();
        br.close();
        bw2.close();
        
        bw = IOAssistance.openWriter("errors.txt");
        Enumeration<String> en = h.keys();
        ArrayList<String> a = new ArrayList<String>();
        while(en.hasMoreElements()) {
            a.add(en.nextElement());
        }
        Collections.sort(a);
        for (String key : a) {
            ArrayList<String> lns = h.get(key);
            if (hasDifferences(lns)) {
                for (String ln : lns) {
                    bw.write(ln);
                    bw.write("\n");
                }

                bw.write(separator);
            }
        }
        bw.close();
    }
    private Regex reVowel = new Regex("", "[aAiIuUfFxXeEoO]");

    
    private Regex reColumns = new Regex("", ".*?\t.*?\t.*?\t.*?\t(.*)");
    public boolean hasDifferences(ArrayList<String> aa) {
        boolean b = false;
        Hashtable<String, Boolean> h = new Hashtable<String, Boolean>();
        for (String a : aa) {
            reColumns.reset(a);
            if (reColumns.find()) {
                String key = reColumns.getGroup(1);
                h.put(key, Boolean.TRUE);
                if (h.size() == 2) {
                    return true;
                }
            } else {
                System.out.println(a);
            }
        }
        return b;
    }
    
    
    public boolean isVowel(String s) {
        reVowel.reset(s);
        return reVowel.find();
    }

    public void addSLP(BufferedWriter bw, String[] fields) throws Exception {
        String pratipadika = fields[3];
        String marker = fields[7];
        String pronunciation = fields[8];
        String delim = "";
        int count = 0;
        String slp = computeSLP(pratipadika, marker, pronunciation);
        int len = fields.length;
        for (int i = 0; i < len; i++) {
            String field = fields[i];
            bw.write(delim);
            bw.write(field);
            delim = "\t";
            if (i == 2) {
                bw.write(delim);
                bw.write(slp);
            }
        }
        bw.write("\n");
    }

    public String computeSLP(String pratipadika, String marker, String pronounciation) {
        if (marker.length() > 0) {
            if (marker.length() > 1) {
                marker = marker.substring(1, marker.length() - 1);
                String[] fields = marker.split(",\\s*");
                for (String field : fields) {
                    pratipadika = highlightMarkers(pratipadika, field);
                }
            } else {
                pratipadika = highlightMarkers(pratipadika, marker);
            }
        }

        return pratipadika;
    }

    public String addMarkers(String pratipadika, String marker, String pronounciation) {
        if (pronounciation.length() > 0) {
            return markPronounciation(pratipadika, pronounciation);
        } else {
            if (marker.length() > 1) {
                marker = marker.substring(1, marker.length() - 1);
                String[] fields = marker.split(",\\s*");
                for (String field : fields) {
                    pratipadika = highlightMarkers(pratipadika, field);
                }
            } else {
                pratipadika = highlightMarkers(pratipadika, marker);
            }

            return pratipadika;
        }
    }

    public String markPronounciation(String pratipadika, String pronunciation) {
        int len = pratipadika.length();
        int idx = 0;
        for (int i = len - 1; i >= 0; i--) {
            if (pratipadika.charAt(i) == pronunciation.charAt(0)) {
                idx = i;
                break;
            }
        }
        return pratipadika.substring(0, idx) + "<span class='red'>" + pronunciation + "</span>" + pratipadika.substring(idx + 1);
    }

    public String highlightMarkers(String pratipadika, String marker) {
        if (vowels.get(marker.charAt(0)) == null) {
            return pratipadika;
        }
        int len = pratipadika.length();
        int idx = 0;
        for (int i = len - 1; i >= 0; i--) {
            if (pratipadika.charAt(i) == marker.charAt(0)) {
                idx = i;
                break;
            }
        }
        return pratipadika.substring(0, idx) + marker + "~" + pratipadika.substring(idx + 1);
    }

    public String addTilde(String pratipadika, String marker) {
        if (vowels.get(marker.charAt(0)) == null) {
            return pratipadika;
        }
        int len = pratipadika.length();
        int idx = 0;
        for (int i = len - 1; i >= 0; i--) {
            if (pratipadika.charAt(i) == marker.charAt(0)) {
                idx = i;
                break;
            }
        }
        return pratipadika.substring(0, idx) + marker + "~" + pratipadika.substring(idx + 1);
    }

    public void compare() {
        try {
            MDhPNew mdhpNew = new MDhPNew("out.xml");
            mdhpNew.parse();
            MDhPPawan mdhpPawan = new MDhPPawan("/Users/ralph/PaniniDB/dhatus.xml");
            mdhpPawan.parse();
            Hashtable<String, String> hpreds = mdhpNew.getPreds();
            Hashtable<String, String> hnew = mdhpNew.getSLPs();
            Hashtable<String, String> hpawan = mdhpPawan.getSLPs();
            ArrayList<String> a = new ArrayList<String>();
            Enumeration<String> en = hnew.keys();
            while (en.hasMoreElements()) {
                a.add(en.nextElement());
            }
            Collections.sort(a);
            for (String key : a) {
                String slpnew = hnew.get(key);
                String slppawan = hpawan.get(key);
                if (!slpnew.equals(slppawan)) {
                    System.out.format("%s(%s): new=%s, pawan=%s\n", key, hpreds.get(key), slpnew, slppawan);
                }
            }
        } catch (Exception ex) {
            System.out.println(ex.toString());
        }
    }

    public void MDhP() {
        try {
            MDhPFixup mf = new MDhPFixup("/Users/ralph/PaniniDB/MDhP/MadhaviyaDhP4.xml");
            mf.parse(null);
            mf.parse(mf.getSLPInfo());
        } catch (Exception ex) {
            System.out.println(ex.toString());
        }
    }

    public int foo2(int n, int d) {
        if (n < d) {
            return 0;
        }
        int div = d;
        int k = 1;
        while ((div << 1) <= n) {
            div = div << 1;
            k = k << 1;
        }
        return 0;
    }

    public void oliverReverseEngineer() throws Exception {
        String db = "/Users/ralph/SanskritLibrary/Oliver/dcs.sql";

        BufferedReader br = IOAssistance.openReader(db);
        String line;
        int lineNumber = 0;
        while ((line = br.readLine()) != null) {
            lineNumber++;
            if (line.toLowerCase().startsWith("create table")) {
                System.out.format("%d. %s\n", lineNumber, line);
            } else {
                if (line.contains("Indikativ")) {
                    System.out.format("**%d. %s\n", lineNumber, line);
                }
                if (line.contains("trivarga")) {
                    System.out.format("%d. %s\n", lineNumber, line);
                }
            }
        }
    }

    public void ocrPrep() throws Exception {
        Config config = new Config("config.xml");

        BufferedWriter bw = IOAssistance.openWriter("ocrprep.txt");
        String dirname = config.catalogEntriesWithFacsimiles; // "/Users/ralph/Downloads/xmlWithFacsimiles";
        File dir = new File(dirname);
        File[] files = dir.listFiles();
        for (File f : files) {
            String fn = f.getName();
            if (fn.endsWith(".xml") && fn.startsWith("penn")) {
                OCRPrep op = new OCRPrep(config.imagesCropped, f.getAbsolutePath(), f.getName());
                bw.write(f.getName());
                bw.write("\n");
                bw.write(op.getDescription());
                bw.write("\n\n");
            }
        }

        bw.close();

        BufferedWriter out = IOAssistance.openWriter("copypages.sh");
        out.write(OCRPrep.getCopyScript());
        out.close();

        out = IOAssistance.openWriter("images.html");
        out.write(OCRPrep.getHTMLScript());
        out.write("</body></html>");
        out.close();

        OCRPrep.dumpElements();
    }

    public void collectDependencyTags(String filename) throws Exception {
        BufferedWriter bw;
        File dir = new File(filename);
        for (File f : dir.listFiles()) {
            if (f.getName().endsWith(".txt")) {
                String text = String.format("<links>%s</links>", IOAssistance.readEntireFile(f.getAbsolutePath()));
                bw = IOAssistance.openWriter("temp.xml");
                bw.write(text);
                bw.close();
                String fn = f.getAbsolutePath();
                fn = fn.substring(0, fn.length() - 4) + ".xml";
                //bw = IOAssistance.openWriter(fn);
                bw = null;
                String versenum = f.getName().substring(0, f.getName().length() - 4);
                if (!versenum.endsWith("s")) {
                    DependencyTags dt = new DependencyTags("temp.xml", versenum, bw);
                    if (bw != null) {
                        bw.close();
                    }
                }
            }
        }

        ArrayList<String> a = DependencyTags.getTags();
        for (String tag : a) {
            System.out.println(tag);
        }

        bw = IOAssistance.openWriter("results.html");
        bw.write(DependencyTags.getHTML());
        bw.write("</body></html>");
        bw.close();
    }

    public void analyzeDistributionForOCR(String filename) throws Exception {
        Hashtable<String, SyllableInfo> h = new Hashtable<String, SyllableInfo>();
        String text = IOAssistance.readEntireFile(filename);
        int len = text.length();
        boolean start = true;
        char ch = text.charAt(0);
        StringBuilder sb = new StringBuilder();
        sb.append(ch);
        for (int i = 1; i < len; i++) {
            ch = text.charAt(i);
            if (start == true) {
            }
        }
    }

    public void createTemplate() throws Exception {
        String filename = "/Users/ralph/SanskritLibrary/Paul/MBhRamaGrammar.xml";
        DependencyTemplate dt = new DependencyTemplate(filename);

        BufferedWriter bw = IOAssistance.openWriter("template.xml");
        bw.write(dt.getDocument());
        bw.close();
    }

    public void createTranscodingPairs() throws Exception {
        TranscoderPairs tp = new TranscoderPairs("/Users/ralph/SanskritLibrary/Oliver/manusmriti.xml");
        ArrayList<TranscoderPairs.ElementInfo> pathsSorted = tp.getPaths();

        for (TranscoderPairs.ElementInfo ei : pathsSorted) {
            System.out.format("%s: %d\n", ei.qName, ei.lineNumber);
            if (ei.qName.contains("@")) {
                ArrayList<String> a = tp.getAttValues(ei.qName);
                for (String v : a) {
                    System.out.format("\t%s\n", v);
                }
            }
        }
    }

    public void extractSentences() throws Exception {
        String textDir = "/Users/ralph/Downloads/_extractions/Text/";
        String mbhFile = "/Users/ralph/Downloads/_extractions/Data/intMBh.txt";
        String ptFile = "/Users/ralph/Downloads/_extractions/Data/intPT.txt";
        Hashtable<String, String[]> fh = new Hashtable<String, String[]>();
        load(textDir, "MBh01AdiParvan.slp", "mbh01_", fh);
        load(textDir, "MBh03VanaParvan.slp", "mbh03_", fh);
        load(textDir, "MBh12ShantiParvan.slp", "mbh12_", fh);
        load(textDir, "ptdb2001.txt", "pt_", fh);

        doExtraction(mbhFile, fh, textDir, "mbhExtractions.txt");
        doExtraction(ptFile, fh, textDir, "ptExtractions.txt");
    }

    public void doExtraction(String sentenceFile, Hashtable<String, String[]> fh,
            String textDir, String outfile) throws Exception {
        Regex re = new Regex("", "^(.+_)(\\d+)\\.xml");
        String data = IOAssistance.readEntireFile(sentenceFile);
        if (data.charAt(0) == 0xFEFF) {
            data = data.substring(1);
        }
        BufferedWriter bw = IOAssistance.openWriter(outfile);

        BufferedReader br = IOAssistance.openReader(sentenceFile);
        String line;
        while ((line = br.readLine()) != null) {
            re.reset(line);
            if (re.find()) {
                String key = re.getGroup(1);
                if (key.charAt(0) == 0xFEFF) {
                    key = key.substring(1);
                }
                int n = Integer.parseInt(re.getGroup(2));
                String[] sentences = fh.get(key);
                if (sentences != null) {
                    String sentence = sentences[n - 1];
                    bw.write(sentence);
                    bw.write("\n");
                } else {
                    System.out.format("key %s not found\n", key);
                }
            } else {
                System.out.format("Malformed line: %s\n", line);
            }
        }

        br.close();
        bw.close();
    }

    public void load(String textDir, String filename, String key, Hashtable<String, String[]> fh) throws Exception {
        String data = IOAssistance.readEntireFile(textDir + filename);
        String[] lines = data.split("\n");
        fh.put(key, lines);
    }

    public void renamingFiles() throws Exception {
        String indir = "/Users/ralph/Downloads/Renaming/Numbering/MBh/Slp/MBh12Slp/";
        String outdir = "/Users/ralph/Downloads/Renaming/Numbering/MBh/Slp/MBh12SlpRenamed/";
        String config = "config.txt";
        this.gen(config);
        this.rename(config, indir, outdir);
    }

    public void gen(String config) throws Exception {
        BufferedWriter bw = IOAssistance.openWriter(config);
        String tag = "mbh12_";
        int firstSentence = 13886;
        int lastSentence = 26175;

        for (int i = firstSentence; i <= lastSentence; i++) {
            bw.write(String.format("%d,%s,%d\n", i, tag, i));
        }
        bw.close();
    }

    public void rename(String configfile, String indir, String outdir) throws Exception {
        String config = IOAssistance.readEntireFile(configfile);
        String[] lines = config.split("\n");
        Regex re = new Regex("", "<solution sentenceNo='(\\d+)(.*)");
        for (String line : lines) {
            String[] fields = line.split(",");
            String orign = fields[0];
            String prefix = fields[1];

            int newn;
            if (fields.length > 2) {
                newn = Integer.parseInt(fields[2]);
            } else {
                newn = Integer.parseInt(orign);
            }
            int increment = 0;
            if (fields.length == 4) {
                increment = Integer.parseInt(fields[3]);
            }
            newn += increment;
            String fnin = String.format("%ssentence%s.xml", indir, orign);
            File f = new File(fnin);
            if (!f.exists()) {
                continue;
            }

            String fnout = String.format("%s%s%d.xml", outdir, prefix, newn);
            BufferedReader br = IOAssistance.openReader(fnin);
            BufferedWriter bw = IOAssistance.openWriter(fnout);
            String s;
            boolean firstLine = true;
            while ((s = br.readLine()) != null) {
                if (firstLine) {
                    firstLine = false;
                    re.reset(s);
                    if (re.find()) {
                        if (!re.getGroup(1).equals(orign)) {
                            System.out.format("File %s has sentence %s instead of %s",
                                    fnin, re.getGroup(1), orign);
                        }
                        s = String.format("<solution prefix='%s' sentenceNo='%d%s",
                                prefix, newn, re.getGroup(2));
                    } else {
                        System.out.format("Unexpected first line of %s\n", fnin);
                        // write it out as is
                    }
                }
                bw.write(s);
                bw.write("\n");
            }
            br.close();
            bw.close();
        }
    }

    @Override
    public int compare(String t, String t1) {
        String[] f = t.split("\\.");
        String[] f1 = t1.split("\\.");
        
        if (!f[0].equals(f1[0])) {
            return Integer.parseInt(f[0]) - Integer.parseInt(f1[0]);
        } else if (!f[1].equals(f1[1])) {
            return Integer.parseInt(f[1]) - Integer.parseInt(f1[1]);
        } else {
            return Integer.parseInt(f[2]) - Integer.parseInt(f1[2]);
        }
    }

    public class SyllableInfo {

        public SyllableInfo() {
            String syllable;
            ArrayList<Integer> lines;
            int count;
        }
    }    
}
