/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package qnd;

/**
 *
 * @author ralph
 */
public class RuleInfo {
    String sutra;
    String tag;
    String ruleset;
    String source;
    String target;
    String lcontext;
    String rcontext;
    String root;
    String affix;
    String optional;
    
    public RuleInfo (String sutra, String tag, String ruleset, String source, String target, String lcontext, String rcontext, String root,
            String affix, String optional) {
        this.sutra = sutra;
        this.tag = tag;
        this.ruleset = ruleset;
        this.source = source;
        this.target = target;
        this.lcontext = lcontext;
        this.rcontext = rcontext;
        this.root = root;
        this.affix = affix;
        this.optional = optional;
    }
    
    @Override 
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("<description ");
        format(sb, tag, "tag");
        format(sb, ruleset, "ruleset");
        format(sb, source, "source");
        format(sb, target, "target");
        format(sb, lcontext, "lcontext");
        format(sb, rcontext, "rcontext");
        format(sb, root, "root");
        format(sb, affix, "affix");
        format(sb, optional, "optional");
        sb.append("/>");
        return sb.toString();
    }
    
    private void format(StringBuilder sb, String value, String name) {
        if (value != null) {
            sb.append(String.format("%s=\"%s\" ", name, fixup(value)));
        }
    }
    
    private String fixup (String s) {
        s = s.replaceAll("`", "");
        s = s.replaceAll(";", "");
        s = s.replaceAll("<", "&lt;");
        return s;
    }
}
