/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package qnd;

import java.io.BufferedReader;
import java.util.ArrayList;
import org.sanskritlibrary.IOAssistance;

/**
 *
 * @author ralph
 */
public class TrailApp {
    String filename;
    BufferedReader br;
    
    public TrailApp(String filename) {
        this.filename = filename;
    }
    
    public void parse() throws Exception {
        ArrayList<TrailPoint> points = new ArrayList<TrailPoint>();
        br = IOAssistance.openReader(filename);
        String line;
        int minNorth = 0;
        int minEast = 0;
        int maxNorth = 0;
        int maxEast = 0;
        int east = 0;
        int north = 0;
        int height = 0;
        int minHeight = 0;
        int maxHeight = 0;
        int number = 0;
        boolean firstLine = true;
        int markerNumber = 1;
        int count = 0;
        while ((line = br.readLine()) != null) {
            if (line.charAt(0) == '#') {
                continue;
            }

            String[] fields = line.split(",");
            number = (int)Math.round(Integer.parseInt(fields[0]));
            north = (int) Math.round(Double.parseDouble(fields[1]));
            east = (int) Math.round(Double.parseDouble(fields[2]));
            height = (int) Math.round(Double.parseDouble(fields[3]));
            String comment = fields[4];
            if (comment.contains("trail")) {
                int x = 0;
                if (comment.contains("marker")) {
                    x = markerNumber++;
                } else if (comment.contains("restroom")) {
                    x = -1;
                }
                points.add(new TrailPoint(number, east, north, height, x));
                if (firstLine) {
                    minNorth = maxNorth = north;
                    minEast = maxEast = east;
                    minHeight = maxHeight = height;
                    firstLine = false;
                } else {
                    if (north > maxNorth) {
                        maxNorth = north;
                    }
                    if (north < minNorth) {
                        minNorth = north;
                    }
                    if (east > maxEast) {
                        maxEast = east;
                    }
                    if (east < minEast) {
                        minEast = east;
                    }
                    if (height > maxHeight) {
                        maxHeight = height;
                    }
                    if (height < minHeight) {
                        minHeight = height;
                    }
                }
            }
            count++;
        }
        
        br.close();
        
        int scale = 1;
        int maxX = 1 + (maxEast - minEast)/scale;
        int maxY = 1 + (maxNorth - minNorth)/scale;
/*
        short[][] buffer = new short[maxY][maxX];
        for (int row = 0; row<maxY; row++) {
            for (int col=0; col<maxX; col++) {
                buffer[row][col] = 0;
            }
        }
*/        
        TrailPoint prev = null;
        for (TrailPoint tp : points) {
            tp.x -= minEast;
            tp.y -= minNorth;
            tp.z -= minHeight;
            int row = tp.y / scale;
            int col = tp.x / scale;
            /*
            if (tp.markerNumber > 0 && buffer[row][col] == 0) {
                buffer[row][col] = (short)tp.markerNumber;
            }
            if (tp.markerNumber == -1) {
                buffer[tp.y / scale][tp.x / scale] = -1;                
            }
            if (prev != null) {          
                int difX = tp.x - prev.x;
                int difY = tp.y - prev.y;
                System.out.format("^x=%d, ^y=%d\n", difX, difY);
            }
            prev = tp;
            */
//            buffer[row][col] = 1;
        }
        
        for (TrailPoint tp : points) {
            if (prev != null) {            
                String horiz = null;
                String vert = null;
                int xinc = tp.x - prev.x;
                if (xinc >= 0) {
                    horiz = "east";                    
                } else {
                    xinc = -xinc;
                    horiz = "west";
                }
                int yinc = tp.y - prev.y;
                if (yinc >= 0) {
                    vert = "north";                    
                } else {
                    yinc = -yinc;
                    vert = "south";
                }
                
                System.out.format("%d->%d. Go %d feet %s and %d feet %s\n", prev.number, tp.number, xinc, horiz, yinc, vert);
            }
            prev = tp;
        }
/*        
        for (int i=0; i<maxY; i++) {
            for (int j=0; j<maxX; j++) {
                if (buffer[i][j] == 1) {
                    System.out.print('.');
                } else {
                    System.out.print(' ');
                }
            }
            System.out.println();
        }
*/        
        double NS = (maxNorth - minNorth)/5280.0;
        double EW = (maxEast - minEast)/5280.0;
        System.out.println(NS);
        System.out.println(EW);
        System.out.format("minheight=%d, maxheight=%d\n", (int)minHeight, (int)maxHeight);
    }
    
// http://stackoverflow.com/questions/1995998/android-get-altitude-by-longitude-and-latitude    
    public void getElevations() throws Exception {
        BufferedReader br = IOAssistance.openReader(filename);
        String line;
        br.readLine();      // skip header
        while ((line=br.readLine()) != null) {
            
        }                
    }
    
// http://maps.googleapis.com/maps/api/elevation/xml?locations=40.9882354,-91.9631201&sensor=true
// https://developers.google.com/maps/documentation/elevation/    
    class TrailPoint {
        int number;
        int x;
        int y;
        int z;
        int markerNumber;
        
        TrailPoint (int number, int x, int y, int z, int markerNumber) {
            this.number = number;
            this.x = x;
            this.y = y;
            this.z = z;
            this.markerNumber = markerNumber;
        }
    }
}
