"use strict";
function init () {
	var map, cnv, ctx, width, height;
	
	map = document.getElementById("idmap");
	cnv = document.createElement("canvas");
	cnv.style.position = 'absolute';		// note: relative won't work because element positioned relative to where it "normally" would appear in the document. This is not precise enough for us.
	cnv.style.top = '0px';
	cnv.style.left = '0px';
	width = map.clientWidth;
	height = map.clientHeight;
	cnv.width = width;
	cnv.height = height;
	map.appendChild(cnv);
	ctx = cnv.getContext("2d");
	ctx.fillStyle = "ff0000";
//	ctx.fillRect(0, 0, width, height);
	
	drawOutline(ctx, width, height);
}


function drawOutline(ctx, width, height) {
	var len, i, point, minX, maxX, minY, maxY, rangeX, rangeY, ratioX, ratioY, maxPointX, maxPointY, minZ, maxZ, middleZ;
	
	len = points.length;
	minX = points[0].x;
	maxX = minX;
	minY = points[0].y;
	maxY = minY;
	minZ = points[0].z;
	maxZ = points[0].z;
	for (i=1; i<len; i++) {
		point = points[i];
		if (point.x < minX) {
			minX = point.x;
		}
		if (point.x > maxX) {
			maxX = point.x;
		}
		if (point.y < minY) {
			minY = point.y;
		}
		if (point.y > maxY) {
			maxY = point.y;
		}
		if (point.z < minZ) {
			minZ = point.z;
		}
		if (point.z > maxZ) {
			maxZ = point.z;
		}
	}
	
	middleZ = minZ + (maxZ-minZ)/2
	
	rangeX = maxX - minX;
	rangeY = maxY - minY;
	
	if (rangeX >= rangeY) {
		ratioX = width/rangeX;
		ratioY = height/rangeX;
	} else {
		ratioX = width/rangeY;
		ratioY = height/rangeY;
	}
	
	
	for (i=0; i<len; i++) {
		point = points[i];
		point.x -= minX;
		point.y -= minY;
		point.x *= ratioX;
		point.y *= ratioY;
		if (i == 0) {
			maxPointX = points[0].x;
			maxPointY = points[0].y;
		} else {
			if (points[i].x > maxPointX) {
				maxPointX = point.x;				
			}
			if (points[i].y > maxPointY) {
				maxPointY = point.y;
			}
		}
		
		if (point.z > middleZ) {
			ctx.fillStyle = 'ff0000';
		} else {
			ctx.fillStyle = '00ff00'
		}
		ctx.fillRect(point.x, height-point.y, 2, 2);
	}	
}