// solve39.js
"use strict";
/*!
 This XWord Info JavaScript program (c) 2010-2012 by Jim Horne.
 All rights reserved.
 */
// http://www.xwordinfo.com/JSON/data.aspx?date=3/2/1981
function GoSolve(puzzleDate) {   // e.g. date=3/2/1981    
    try {
        bLocalStorage = window.localStorage ? true : false;
        bLSBug = false;
    } catch (t) {
        bLocalStorage = false;
        bLSBug = true;
    }

    TTBind(".dtlink", false);   // defined in xw18.min.js
    if (puzzleDate.length > 0) {
        puzzleDate += "&";
    }
    puzzleDate += "track=true",
            // o = row, s = col, 
            $.getJSON("/JSON/data.aspx", puzzleDate, // www.xwordinfo.com/JSON/data.aspx?date=3/2/1981
            function(puzzleData) {
                var index1D, clueIdx, row, jqRow, col, jqCell, gridnum, answerLetter, clue, clueNumber, clueText, idx, v;
                if (puz = puzzleData, !puz) {
                    $("#title").html("");
                    return;
                }

                if ((puz.type !== "diagramless" ||
                     confirm("This will reveal the grid shape of the diagramless puzzle. Do you want to continue?")) && (puz.code === puz.id2 || puz.admin)) {
                    if (!puz.type) {
                        if (puz.dow !== "Sunday") {
                            $("#title").html(puz.title + " by " + puz.author);
                        } else {
                            $("#title").html("Sunday " + puz.date + " NY Times, " + puz.title + " by " + puz.author);
                            $("#AcrossClues,#DownClues").css("width", "inherit");
                        }
                    }
                    pt = $("#puzTable")[0];
                    index1D = 0;
                    clueIdx = 0; 
                    for (row = 0; row < puz.size.rows; row++)
                        jqRow = pt.insertRow(row);
                        for (col = 0; col < puz.size.cols; col++)
                            jqCell = jqRow.insertCell(col);
                            gridnum = puz.gridnums[index1D];
                            if (gridnum == 0) {
                                gridnum = "";
                            }
                            answerLetter = puz.grid[index1D];
                            if (answerLetter == ".") {
                                $(jqCell).addClass("black");
                            } else {
                                jqCell.innerHTML = "<div class='grid'>" + gridnum + "<\/div><div class='letter'><\/div>";
                                if (puz.circles != null && puz.circles[index1D] == 1) {
                                    if (puz.shadecircles) {
                                        $(jqCell).addClass("shade")
                                    } else {
                                        $(jqCell).addClass("solcirc");
                                    }
                                }
                            }
                            index1D++;
                            if (puz.id == null) {
                                wlsKey = "slv" + (puz.type ? "v" : "") + puz.date;
                                $("#puzCopy").html("&copy; " + puz.copyright + ", Editor: " + puz.editor);
                            } else {
                                wlsKey = "slv" + puz.id, SetTopLeft();
                            }
                            for (clueIdx in puz.clues.across) {
                                clue = FixUp(puz.clues.across[clueIdx]);
                                idx = clue.indexOf(".");
                                clueNumber = clue.substr(0, idx);
                                clueText = clue.substr(idx + 2);
                                acClues[clueNumber] = clueText;
                                $("#AcrossClues").append("<div id='acclue" + clueNumber + "'>" + clue + "<\/div>");
                            }
                            
                            for (clueIdx in puz.clues.down) {
                                clue = FixUp(puz.clues.down[clueIdx]);
                                idx = clue.indexOf(".");
                                clueNumber = clue.substr(0, idx);
                                clueText = clue.substr(idx + 2);
                                dnClues[clueNumber] = clueText;
                                $("#DownClues").append("<div id='dnclue" + clueNumber + "'>" + clue + "<\/div>");
                            }
                            
                            bClockHidden = $.cookie(ckHide) == "true";
                            bClockHidden || $("#clock").show(), gridHeight = $("#puzTable").height(), bExpandClues = $.cookie(ckExp) == "true", $("#AcrossClues, #DownClues").height(bExpandClues ? "" : gridHeight - 20), bNoSkip = $.cookie(ckNoSkip) == "true", puz.notepad && (v = $("#mainTab").outerWidth(), $("#puzNotepad").width(v - 18).html("<b>Notepad:<\/b> " + puz.notepad).show()), puz.acrossmap != null && $("td:has(div)", pt).tooltip({bodyHandler: function() {
                            var u = this.parentNode.rowIndex, f = this.cellIndex, t = u * puz.size.cols + f, i = puz.clues.across[puz.acrossmap[t]].replace(".", " Across: "), r = puz.clues.down[puz.downmap[t]].replace(".", " Down: "), n = "";
                            return i != undefined && (n += "<div>" + i + "<\/div>"), r != undefined && (n += "<div>" + r + "<\/div>"), n
                        }, extraClass: "ttlite"}), HighlightCurCell(), SetHandlers(), Restore()
                }
            });
    try {
        aud = document.createElement("audio"), aud.canPlayType("audio/mpeg") ? (bCanPlayAudio = !0, aud.src = "special/Congrats.mp3") : aud.canPlayType('audio/ogg; codecs="vorbis"') && (bCanPlayAudio = !0, aud.src = "special/Congrats.ogg"), bCanPlayAudio && aud.load()
    } catch (t) {
        bCanPlayAudio = !1
    }
}

function FixUp(n) {
    return n.replace("&lt;/", "<\/").replace("&lt;", "<").replace("&gt;", ">")
}

function SetTopLeft() {
    for (curRow = 0, curCol = 0; IsBlack(curRow, curCol); )
        curCol++
}

function HighlightCurCell() {
    var n, t, i, f, e, r, u;
    for ($("td", "#puzTable").removeClass("current").removeClass("curword"), $("div", ".cluelist").removeClass("curListClue").removeClass("othListClue"), n = curRow, t = curCol, (n < 0 || n >= puz.size.rows || t < 0 || t >= puz.size.cols || IsBlack(n, t)) && (alert("Invalid cell: r is " + n + " and c is " + t), SetTopLeft()), i = $(pt.rows[n].cells[t]), i.addClass("current"); t > 0; ) {
        if (IsBlack(n, t - 1))
            break;
        t--
    }
    if (f = CellNum(n, t), curDir)
        while (t < puz.size.cols) {
            if (i = $(pt.rows[n].cells[t]), i.hasClass("black"))
                break;
            t != curCol && i.addClass("curword"), t++
        }
    for (n = curRow, t = curCol; n > 0; ) {
        if (IsBlack(n - 1, t))
            break;
        n--
    }
    if (e = CellNum(n, t), !curDir)
        while (n < puz.size.rows) {
            if (i = $(pt.rows[n].cells[t]), i.hasClass("black"))
                break;
            n != curRow && i.addClass("curword"), n++
        }
    r = $("#acclue" + f), u = $("#dnclue" + e), curDir ? $("#bigClue").html(r.length > 0 ? f + ". " + acClues[f] : "-") : $("#bigClue").html(u.length > 0 ? e + ". " + dnClues[e] : "-"), r.length > 0 && (r.addClass(curDir ? "curListClue" : "othListClue"), ScrollIntoView($("#AcrossClues"), r)), u.length > 0 && (u.addClass(curDir ? "othListClue" : "curListClue"), ScrollIntoView($("#DownClues"), u))
}

function ScrollIntoView(n, t) {
    var f = n.scrollTop(), i = n.position().top, r = t.position().top, e = r + t.height(), u;
    r < i ? n.scrollTo(r + f - i) : (u = e - (i + n.height()), u > 0 && n.scrollTo(f + u))
}

function SetHandlers() {
    $("td", "#puzTable").click(function() {
        $(this).hasClass("black") || (curRow = this.parentNode.rowIndex, curCol = this.cellIndex, HighlightCurCell())
    }), $("div div", ".cluelist").click(function() {
        curDir = this.id.substr(0, 2) == "ac";
        var n = this.id.substr(6);
        SetCurCellFromNum(n), HighlightCurCell()
    }), $("td:has(div)", "#puzTable").hover(function() {
        $("body").css("cursor", "pointer")
    }, function() {
        $("body").css("cursor", "default")
    }), $(".cluelist div div").hover(function() {
        $("body").css("cursor", "pointer")
    }, function() {
        $("body").css("cursor", "default")
    }), $("td", "#puzTable").bind("contextmenu", function() {
        if (!$(this).hasClass("black"))
            return SetCurDir(!curDir), curRow = this.parentNode.rowIndex, curCol = this.cellIndex, HighlightCurCell(), !1
    }), $(window).blur(function() {
        PauseTimer()
    }), $(window).focus(function() {
        ResumeTimer()
    }), SetKeyboardHandler()
}

function SetKeyboardHandler() {
    $(document).keydown(function(n) {
        bKeyPressed = !0, $("#explode").html(" ");
        var t = n.keyCode, i;
        if (t == 9 || t == 13)
            return bSmartJump ? t == 9 ? (bIgnoreSmart = !0, Tab(n.shiftKey)) : bIgnoreSmart ? NextBlankTab() : SmartJump() : Tab(n.shiftKey), !1;
        if (t >= 65 && t <= 90)
            bFirstKeyPressed = !0, bIgnoreSmart = !1, i = t == 32 ? "" : String.fromCharCode(t), CellLet(curRow, curCol, i), NextLetter();
        else {
            if (t >= 37 && t <= 40)
                return n.ctrlKey ? (t == 37 || t == 39 ? SetCurDir(!0) : SetCurDir(!1), HighlightCurCell()) : t != 37 && t != 39 || curDir ? (t == 38 || t == 40) && curDir ? (curDir = !1, IsBlank(curRow, curCol) || Move(t == 38 ? -1 : 1, 0), HighlightCurCell()) : t == 37 ? n.shiftKey ? Tab(!0) : Move(0, -1) : t == 38 ? n.shiftKey ? Tab(!0) : Move(-1, 0) : t == 39 ? n.shiftKey ? Tab(!1) : Move(0, 1) : t == 40 && (n.shiftKey ? Tab(!1) : Move(1, 0)) : (curDir = !0, IsBlank(curRow, curCol) || Move(0, t == 37 ? -1 : 1), HighlightCurCell()), !1;
            if (t == 46)
                return CellLet(curRow, curCol, ""), !1;
            if (t == 32)
                return CellLet(curRow, curCol, ""), curDir ? curCol < puz.size.cols - 1 && !IsBlack(curRow, curCol + 1) && curCol++ : curRow < puz.size.rows - 1 && !IsBlack(curRow + 1, curCol) && curRow++, HighlightCurCell(), !1;
            if (t == 8)
                return CellLet(curRow, curCol, ""), curDir ? curCol > 0 && !IsBlack(curRow, curCol - 1) && curCol-- : curRow > 0 && !IsBlack(curRow - 1, curCol) && curRow--, HighlightCurCell(), !1;
            if (t == 36) {
                if (n.shiftKey)
                    SetTopLeft(), HighlightCurCell();
                else if (curDir) {
                    while (curCol > 0 && !IsBlack(curRow, curCol - 1))
                        curCol--;
                    HighlightCurCell()
                } else {
                    while (curRow > 0 && !IsBlack(curRow - 1, curCol))
                        curRow--;
                    HighlightCurCell()
                }
                return!1
            }
            if (t == 35) {
                if (n.shiftKey) {
                    for (curRow = puz.size.rows - 1, curCol = puz.size.cols - 1; IsBlack(curRow, curCol); )
                        curCol--;
                    HighlightCurCell()
                } else if (curDir) {
                    while (curCol < puz.size.cols - 1 && !IsBlack(curRow, curCol + 1))
                        curCol++;
                    HighlightCurCell()
                } else {
                    while (curRow < puz.size.rows - 1 && !IsBlack(curRow + 1, curCol))
                        curRow++;
                    HighlightCurCell()
                }
                return!1
            }
            if (t == 45)
                return EnterRebus(), !1;
            if (t == 119)
                return RevealWord(), !1;
            if (t == 120)
                return RevealAll(), !1;
            if (t == 118)
                return Options(), !1
        }
    })
}

function EnterRebus() {
    $(document).off("keydown"), $("#rebustext").attr("value", CellLet(curRow, curCol)), $("#dialog").dialog({modal: !0, beforeClose: function() {
            $(this).off(), SetKeyboardHandler()
        }, buttons: [{text: "OK", click: function() {
                    SubmitRebus(), bKeyPressed = !0, $(this).dialog("close")
                }}, {text: "Cancel", click: function() {
                    $(this).dialog("close")
                }}]}).keydown(function(n) {
        if (n.keyCode == 13)
            return SubmitRebus(), bKeyPressed = !0, $(this).dialog("close"), !1
    })
}

function Help() {
    $(document).off("keydown"), PauseTimer(), $("#help").dialog({modal: !0, beforeClose: function() {
            SetKeyboardHandler(), ResumeTimer()
        }, width: 600, buttons: {Ok: function() {
                $(this).dialog("close")
            }}})
}

function Options() {
    var n, t, i, r;
    $(document).off("keydown"), PauseTimer(), n = $("#clock"), t = $("#ckClock"), t.attr("checked", !bClockHidden), i = $("#ckClues"), i.attr("checked", bExpandClues), r = $("#ckSmart"), r.attr("checked", bSmartJump), bNoSkip ? $("#rbSquare").click() : $("#rbBlank").click(), $("#optionbox").dialog({modal: !0, beforeClose: function() {
            SetKeyboardHandler(), ResumeTimer()
        }, width: 400, buttons: {Ok: function() {
                bClockHidden = !t.is(":checked"), bClockHidden ? (setCookie(ckHide), n.hide()) : (timer ? ShowTime() : ShowTime(msPause), deleteCookie(ckHide), n.show()), bExpandClues = i.is(":checked"), $("#AcrossClues, #DownClues").height(bExpandClues ? "" : gridHeight - 20), bExpandClues ? setCookie(ckExp) : deleteCookie(ckExp), bNoSkip = $("input[name=skip]:checked").val() == "square", bNoSkip ? setCookie(ckNoSkip) : deleteCookie(ckNoSkip), bSmartJump = r.is(":checked"), bSmartJump ? setCookie(ckSmart) : deleteCookie(ckSmart), $(this).dialog("close")
            }}})
}

function SubmitRebus() {
    for (var r = $("#rebustext").attr("value").toUpperCase(), i = "", t, n = 0; n < r.length; n++)
        if (t = r.charAt(n), t >= "A" && t <= "Z")
            i += t;
        else
            break;
    CellLet(curRow, curCol, i), i != "" && NextLetter()
}

function GetAcrossNum(n, t) {
    while (t > 0) {
        if (IsBlack(n, t - 1))
            break;
        t--
    }
    return CellNum(n, t)
}

function GetDownNum(n, t) {
    while (n > 0) {
        if (IsBlack(n - 1, t))
            break;
        n--
    }
    return CellNum(n, t)
}

function SetCurCellFromNum(n) {
    for (var t = 0; t < puz.size.rows * puz.size.cols; t++)
        if (puz.gridnums[t] == n)
            break;
    curRow = Math.floor(t / puz.size.cols), curCol = t % puz.size.cols
}

function Move(n, t) {
    for (var i = curRow, r = curCol; ; ) {
        if (i += n, r += t, i < 0 || i >= puz.size.rows)
            return;
        if (r < 0 || r >= puz.size.cols)
            return;
        if (!IsBlack(i, r)) {
            curDir = n == 0, curRow = i, curCol = r, HighlightCurCell();
            return
        }
    }
}

function NextLetter() {
    var n = curRow, t = curCol, i, r;
    if (curDir) {
        for (t++; t < puz.size.cols && !IsBlack(n, t); ) {
            if (bNoSkip || IsBlank(n, t)) {
                curCol = t, HighlightCurCell();
                return
            }
            t++
        }
        if (bNoSkip)
            return;
        for (i = t - 1; t > 0 && !IsBlack(n, t - 1); )
            t--;
        while (t < puz.size.cols && !IsBlack(n, t)) {
            if (IsBlank(n, t)) {
                curCol = t, HighlightCurCell();
                return
            }
            t++
        }
        curCol < i && curCol++, HighlightCurCell()
    } else {
        for (n++; n < puz.size.rows && !IsBlack(n, t); ) {
            if (bNoSkip || IsBlank(n, t)) {
                curRow = n, HighlightCurCell();
                return
            }
            n++
        }
        if (bNoSkip)
            return;
        for (r = n - 1; n > 0 && !IsBlack(n - 1, t); )
            n--;
        while (n < puz.size.rows && !IsBlack(n, t)) {
            if (IsBlank(n, t)) {
                curRow = n, HighlightCurCell();
                return
            }
            n++
        }
        curRow < r && curRow++, HighlightCurCell()
    }
}

function Tab(n) {
    var i = curRow, r = curCol, u, t;
    if (curDir ? (u = GetAcrossNum(i, r), t = $("#acclue" + u)) : (u = GetDownNum(i, r), t = $("#dnclue" + u)), n ? t.prev().attr("id") ? t = t.prev() : curDir ? (t = $("div:last", "#DownClues"), curDir = !1) : (t = $("div:last", "#AcrossClues"), curDir = !0) : t.next().attr("id") ? t = t.next() : curDir ? (t = $("div:first", "#DownClues"), curDir = !1) : (t = $("div:first", "#AcrossClues"), curDir = !0), u = t.attr("id").substr(6), SetCurCellFromNum(u), i = curRow, r = curCol, curDir)
        while (r < puz.size.cols && !IsBlack(i, r)) {
            if (IsBlank(i, r)) {
                curCol = r, HighlightCurCell();
                return
            }
            r++
        }
    else
        while (i < puz.size.rows && !IsBlack(i, r)) {
            if (IsBlank(i, r)) {
                curRow = i, HighlightCurCell();
                return
            }
            i++
        }
    HighlightCurCell()
}

function NextBlankTab() {
    if (IsGridFull())
        IsCorrect() || Tab();
    else
        do
            Tab();
        while (IsCurWordFull())
}

function IsCurWordFull() {
    var n = curRow, t = curCol;
    if (curDir) {
        while (t > 0 && !IsBlack(n, t - 1))
            t--;
        while (t < puz.size.cols && !IsBlack(n, t)) {
            if (IsBlank(n, t))
                return!1;
            t++
        }
    } else {
        while (n > 0 && !IsBlack(n - 1, t))
            n--;
        while (n < puz.size.rows && !IsBlack(n, t)) {
            if (IsBlank(n, t))
                return!1;
            n++
        }
    }
    return!0
}

function IsGridFull() {
    for (var t, n = 0; n < puz.size.rows; n++)
        for (t = 0; t < puz.size.cols; t++)
            if (!IsBlack(n, t) && IsBlank(n, t))
                return!1;
    return!0
}

function GetPct(n, t, i) {
    for (var r = 0, u = 0, f = i ? 0 : 1, e = i ? 1 : 0; n < puz.size.rows && t < puz.size.cols && !IsBlack(n, t); )
        u++, IsBlank(n, t) || r++, n += f, t += e;
    return u == r ? 0 : r / u
}

function IsBlack(n, t) {
    return $(pt.rows[n].cells[t]).hasClass("black")
}

function IsBlank(n, t) {
    return $(pt.rows[n].cells[t].childNodes[1]).html() == ""
}

function CellLet(n, t, i) {
    var r = $(pt.rows[n].cells[t].childNodes[1]);
    return i != null ? r.html(i) : i = r.html(), i
}

function CellNum(n, t, i) {
    var r = $(pt.rows[n].cells[t].childNodes[0]);
    return i ? r.html(i) : i = r.html(), i
}

function IsCorrect() {
    for (var t, i, r = 0, n = 0; n < puz.size.rows; n++)
        for (t = 0; t < puz.size.cols; t++)
            if (i = puz.grid[r++], i != "." && i.charAt(0) != CellLet(n, t).charAt(0))
                return!1;
    return $("#paused").html(""), !0
}

function ClearAll() {
    if (PauseTimer(), $("div.letter:not(:empty)", "#puzTable").length == 0) {
        ResumeTimer(0);
        return
    }
    $(document).off("keydown"), $("#clearbox").dialog({modal: !0, beforeClose: function(n) {
            SetKeyboardHandler(), (n.which == 1 || n.which == 27) && ResumeTimer()
        }, buttons: [{text: "Yes", click: function() {
                    $("#puzTable .letter").html(""), $("#congrats").hide(500), bLocalStorage && window.localStorage.removeItem(wlsKey), SetTopLeft(), curDir = !0, bIgnoreSmart = !1, HighlightCurCell(), $("#clock").html("0:00"), StartTimer(0), $(this).dialog("close")
                }}, {text: "No", click: function() {
                    ResumeTimer(), $(this).dialog("close")
                }}]})
}

function RevealWord() {
    var n = curRow, t = curCol;
    if (curDir) {
        while (t > 0 && !IsBlack(n, t - 1))
            t--;
        while (t < puz.size.cols && !IsBlack(n, t))
            CellLet(n, t, puz.grid[n * puz.size.cols + t]), t++
    } else {
        while (n > 0 && !IsBlack(n - 1, t))
            n--;
        while (n < puz.size.rows && !IsBlack(n, t))
            CellLet(n, t, puz.grid[n * puz.size.cols + t]), n++
    }
    bKeyPressed = !0
}

function RevealWrong() {
    $("td", "#puzTable").removeClass("current").removeClass("curword").each(function(n) {
        var t = $(this).children(".letter");
        t.length > 0 && t.html() != "" && t.html() != puz.grid[n] && $(this).addClass("wrong")
    }), setTimeout("$('td', '#puzTable').removeClass('wrong'); HighlightCurCell();", 1e3)
}

function RevealAll() {
    var n, t;
    if (PauseTimer(), confirm("Are you sure you want to reveal the entire solution?")) {
        for (n = 0; n < puz.size.rows; n++)
            for (t = 0; t < puz.size.cols; t++)
                CellLet(n, t, puz.grid[n * puz.size.cols + t]);
        Save()
    } else
        ResumeTimer()
}

function Save(n) {
    var u, t, i, r, f, e;
    if (IsCorrect() && ($("td", "#puzTable").removeClass("current").removeClass("curword"), $("div", ".cluelist").removeClass("curListClue").removeClass("othListClue"), $("#bigClue").html("&nbsp;"), ShowCongrats(), timer != null && clearTimeout(timer), timer = null), bLocalStorage) {
        for (n == null && (n = CalcTime()), u = !0, t = puz.date + "~" + n + "~", i = 0; i < puz.size.rows; i++)
            for (r = 0; r < puz.size.cols; r++)
                IsBlack(i, r) || (f = CellLet(i, r), e = f.length, e == 0 ? t += " " : e == 1 ? (t += f, u = !1) : (t += "{" + f + "}", u = !1));
        if (u)
            window.localStorage.removeItem(wlsKey);
        else
            try {
                window.localStorage[wlsKey] = t
            } catch (o) {
                MakekRoom(), window.localStorage[wlsKey] = t
            }
    }
}

function Restore() {
    var r = null, e, u, i, n, t, f, o;
    if (bLocalStorage && (r = window.localStorage[wlsKey]), !bLocalStorage || !r) {
        ShowTime(0), StartTimer(0);
        return
    }
    for (e = r.split("~"), msPause = e[1], dtStart = new Date, dtStart = dtStart.getTime() - msPause, ShowTime(msPause), u = e[2], i = 0, n = 0; n < puz.size.rows; n++)
        for (t = 0; t < puz.size.cols; t++)
            if (!IsBlack(n, t))
                if (f = u.charAt(i++), f == "{") {
                    for (o = ""; u.charAt(i) != "}"; )
                        o += u.charAt(i++);
                    CellLet(n, t, o), i++
                } else
                    CellLet(n, t, f == " " ? "" : f), r;
    IsCorrect() ? ShowCongrats(!1) : StartTimer(msPause)
}

function StartTimer(n) {
    n == null && (n = 0), dtStart = new Date, dtStart = dtStart.getTime() - n, timer && clearTimeout(timer), $("#paused").hide(), timer = setInterval("UpdateTimer()", 1e3)
}

function UpdateTimer() {
    bKeyPressed && Save(), ShowTime(), bKeyPressed = !1
}

function ShowTime(n) {
    if (!bClockHidden) {
        n == null && (n = CalcTime());
        var i = Math.floor(n / 1e3), t = i % 60, r = Math.floor((i - t) / 60);
        $("#clock").html(r + ":" + (t < 10 ? "0" + t : t))
    }
}

function PauseTimer() {
    IsCorrect() || (msPause = CalcTime(), Save(msPause), bClockHidden || $("#paused").show()), timer && (clearTimeout(timer), timer = null)
}

function ResumeTimer(n) {
    n != null && (msPause = n), $("#paused").hide(), IsCorrect() || (ShowTime(msPause), StartTimer(msPause))
}

function CalcTime() {
    var n = new Date;
    return n = n.getTime(), n - dtStart
}

function ShowCongrats(n) {
    if (n == undefined && (n = !0), bCanPlayAudio && n)
        try {
            aud.play()
        } catch (i) {
        }
    var t = $("#puzTable").width();
    $("#congrats").width(t - 12).show(500)
}

function SetCurDir(n) {
    n ? (curCol > 0 && !IsBlack(curRow, curCol - 1) || curCol < puz.size.cols - 1 && !IsBlack(curRow, curCol + 1)) && (curDir = !0) : (curRow > 0 && !IsBlack(curRow - 1, curCol) || curRow < puz.size.rows - 1 && !IsBlack(curRow + 1, curCol)) && (curDir = !1)
}

function Trace(n) {
    var t = $("#explode");
    t.html(t.html() + n)
}

function ExAppend(n) {
    document.getElementById("explode").innerHTML += n
}

function SmartJump() {
    Tab()
}

var curRow = 0, 
        curCol = 0, 
        curDir = !0, 
        acClues = [], 
        dnClues = [], 
        puz, 
        pt, 
        dtStart, 
        msPause = 0, 
        timer = null, 
        wlsKey, 
        gridHeight, 
        bKeyPressed = false, 
        bExpandClues = false, 
        bClockHidden = false, 
        bSmartJump = false, 
        bIgnoreSmart = false, 
        bNoSkip = false, 
        ckHide = "hideClock", 
        ckExp = "expClues", 
        ckSmart = "smart", 
        ckNoSkip = "skip", 
        bLocalStorage = true, 
        bLSBug = false, 
        aud, 
        bCanPlayAudio = false, 
        bFirstKeyPressed = false;